CREATE DEFINER=`root`@`localhost` FUNCTION `verhoeff_check`(NUMBER bigint(18), ACTION tinyint(1)) RETURNS tinyint(1)
BEGIN

	DECLARE c tinyint ;
	DECLARE len int;
	DECLARE m tinyint;
	DECLARE n varchar(255);
	DECLARE i smallint;
	
	/* Declare the Arrays */
	DECLARE d char(100);
	DECLARE p char(80);
	DECLARE inv char(10);
	SET d='0123456789123406789523401789563401289567401239567859876043216598710432765982104387659321049876543210';
	SET p='01234567891576283094580379614289160435279453126870428657390127938064157046913258';
	SET inv='0432156789'	;

	/* Start Processing */
	SET c = 0 ;
	SET n = Reverse(NUMBER) ;
	SET len = LENGTH(n);

	SET i=0 ;
	WHILE i < len do
		IF ACTION = 1  THEN
				/* Do the CalcChecksum */
				SET m = substr(p,(((i+1) mod 8)*10)+ (substr(n,i+1,1) )+1, 1) ;
		ELSE
				/* Do the Checksum */
				SET m = substr(p,((i mod 8)*10)+ (substr(n,i+1,1))+1,1) ;
		END IF ;

		SET c = substr(d,(c*10+m+1),1);
		SET i=i+1 ;
	END WHILE ;

	IF ACTION = 1 THEN
				/* Do the CalcChecksum */
				SET c = substr(inv,c+1,1)  ;
	END IF;

	RETURN  c ;

END